package fr.soleil.docking.infonode.view;

import java.awt.Component;

import javax.swing.Icon;
import javax.swing.JComponent;

import net.infonode.docking.RootWindow;
import net.infonode.docking.util.DockingUtil;
import fr.soleil.docking.view.AbstractViewFactory;
import fr.soleil.docking.view.IView;

/**
 * InfoNode implementation of {@link AbstractViewFactory}
 * 
 * @author girardot
 */
public class InfoNodeViewFactory extends AbstractViewFactory {

    public InfoNodeViewFactory() {
        super();
    }

    @Override
    public IView addView(String title, Icon icon, Component component, Object id, JComponent dockingArea) {
        IView addedView = null;
        boolean added = false;
        if (id != null) {
            synchronized (views) {
                if (!views.containsKey(id)) {
                    addedView = new InfoNodeView(title, icon, component, id);
                    views.put(id, addedView);
                    added = true;
                }
                addedView = views.get(id);
            }
        }
        if ((addedView != null) && added) {
            InfoNodeView view = (InfoNodeView) addedView;
            if (dockingArea instanceof RootWindow) {
                view.getWindowProperties().getTabProperties().getNormalButtonProperties().getCloseButtonProperties()
                        .setVisible(false);
                view.getWindowProperties().getTabProperties().getHighlightedButtonProperties()
                        .getCloseButtonProperties().setVisible(false);
                DockingUtil.addWindow(view, (RootWindow) dockingArea);
            } else {
                synchronized (support) {
                    support.firePropertyChange(VIEWS, null, addedView);
                }
            }
        }
        return addedView;
    }

}
